## jattach 1.5

=== Makefile ===
JATTACH_VERSION=1.5

ifneq ($(findstring Windows,$(OS)),)
  CL=cl.exe
  CFLAGS=/O2 /D_CRT_SECURE_NO_WARNINGS
  JATTACH_EXE=jattach.exe
else 
  UNAME_S:=$(shell uname -s)
  ifneq ($(findstring FreeBSD,$(UNAME_S)),)
    CC=cc
    CFLAGS=-O2
    JATTACH_EXE=jattach
  else
    ROOT_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
    RPM_ROOT=$(ROOT_DIR)/build/rpm
    SOURCES=$(RPM_ROOT)/SOURCES
    SPEC_FILE=jattach.spec
    CC=gcc
    CFLAGS=-O2
    JATTACH_EXE=jattach
  endif
endif

all: build build/$(JATTACH_EXE)

build:
	mkdir -p build

build/jattach: src/jattach_posix.c
	$(CC) $(CFLAGS) -DJATTACH_VERSION=\"$(JATTACH_VERSION)\" -o $@ $^

build/jattach.exe: src/jattach_windows.c
	$(CL) $(CFLAGS) /DJATTACH_VERSION=\"$(JATTACH_VERSION)\" /Fobuild/jattach.obj /Fe$@ $^ advapi32.lib /link /SUBSYSTEM:CONSOLE,5.02

clean:
	rm -rf build

$(RPM_ROOT):
	mkdir -p $(RPM_ROOT)

rpm-dirs: $(RPM_ROOT)
	mkdir -p $(RPM_ROOT)/SPECS
	mkdir -p $(SOURCES)/bin
	mkdir -p $(RPM_ROOT)/BUILD
	mkdir -p $(RPM_ROOT)/SRPMS
	mkdir -p $(RPM_ROOT)/RPMS
	mkdir -p $(RPM_ROOT)/tmp

rpm: rpm-dirs build build/$(JATTACH_EXE)
	cp $(SPEC_FILE) $(RPM_ROOT)/
	cp build/jattach $(SOURCES)/bin/
	rpmbuild -bb \
                --define '_topdir $(RPM_ROOT)' \
                --define '_tmppath $(RPM_ROOT)/tmp' \
                --clean \
                --rmsource \
                --rmspec \
                --buildroot $(RPM_ROOT)/tmp/build-root \
                $(RPM_ROOT)/jattach.spec

=== debian/changelog ===
jattach (1.5-2) unstable; urgency=medium

  * Pass on CPPFLAGS and LDFLAGS as well at build time.
    Refreshed in d/patches/do-not-override-CFLAGS
  * Source-only upload to unstable to allow testing migration.

 -- Sven Hoexter <hoexter@debian.org>  Fri, 13 Sep 2019 16:52:23 +0200

jattach (1.5-1) unstable; urgency=medium

  * Initial release (Closes: #939577)

 -- Sven Hoexter <hoexter@debian.org>  Thu, 22 Aug 2019 17:33:50 +0200

=== debian/control ===
Source: jattach
Section: java
Priority: optional
Maintainer: Sven Hoexter <hoexter@debian.org>
Build-Depends: debhelper-compat (=12)
Standards-Version: 4.4.0
Homepage: https://github.com/apangin/jattach
Vcs-Browser: https://git.sven.stormbind.net/?p=sven/jattach.git
Vcs-Git: https://git.sven.stormbind.net/jattach.git

Package: jattach
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JVM Dynamic Attach utility all in one jmap jstack jcmd jinfo
 jattach is a utility implementing commands for the JVM Dynamic Attach
 mechanism. Instead of installing a complete JDK you can use this small
 utility to query information from your running JVM.

## jattach 2.0

=== Makefile ===
--- 
+++ 
@@ -1,35 +1,46 @@
-JATTACH_VERSION=1.5
+JATTACH_VERSION=2.0
 
 ifneq ($(findstring Windows,$(OS)),)
   CL=cl.exe
   CFLAGS=/O2 /D_CRT_SECURE_NO_WARNINGS
   JATTACH_EXE=jattach.exe
+  JATTACH_DLL=jattach.dll
 else 
+  CFLAGS ?= -O3
+  JATTACH_EXE=jattach
+
   UNAME_S:=$(shell uname -s)
-  ifneq ($(findstring FreeBSD,$(UNAME_S)),)
-    CC=cc
-    CFLAGS=-O2
-    JATTACH_EXE=jattach
+  ifeq ($(UNAME_S),Darwin)
+    JATTACH_DLL=libjattach.dylib
   else
+    JATTACH_DLL=libjattach.so
+  endif
+
+  ifeq ($(UNAME_S),Linux)
     ROOT_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
     RPM_ROOT=$(ROOT_DIR)/build/rpm
     SOURCES=$(RPM_ROOT)/SOURCES
     SPEC_FILE=jattach.spec
-    CC=gcc
-    CFLAGS=-O2
-    JATTACH_EXE=jattach
   endif
 endif
 
+
+.PHONY: all dll clean rpm-dirs rpm
+
 all: build build/$(JATTACH_EXE)
+
+dll: build build/$(JATTACH_DLL)
 
 build:
 	mkdir -p build
 
-build/jattach: src/jattach_posix.c
-	$(CC) $(CFLAGS) -DJATTACH_VERSION=\"$(JATTACH_VERSION)\" -o $@ $^
+build/jattach: src/posix/*.c src/posix/*.h
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -DJATTACH_VERSION=\"$(JATTACH_VERSION)\" -o $@ src/posix/*.c
 
-build/jattach.exe: src/jattach_windows.c
+build/$(JATTACH_DLL): src/posix/*.c src/posix/*.h
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -DJATTACH_VERSION=\"$(JATTACH_VERSION)\" -fPIC -shared -fvisibility=hidden -o $@ src/posix/*.c
+
+build/jattach.exe: src/windows/jattach.c
 	$(CL) $(CFLAGS) /DJATTACH_VERSION=\"$(JATTACH_VERSION)\" /Fobuild/jattach.obj /Fe$@ $^ advapi32.lib /link /SUBSYSTEM:CONSOLE,5.02
 
 clean:

=== debian/changelog ===
jattach (2.0-1) unstable; urgency=medium

  * New upstream release.
    + Adds OpenJ9 support.
    + Improves namespace awareness.
  * Drop debian/patches/do-not-override-CFLAGS - fixed upstream.
  * Update Standards-Version to 4.5.1 - no changes required.
  * Raise debhelper-compat level from 12 to 13.

 -- Sven Hoexter <hoexter@debian.org>  Mon, 16 Aug 2021 20:06:29 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: java
 Priority: optional
 Maintainer: Sven Hoexter <hoexter@debian.org>
-Build-Depends: debhelper-compat (=12)
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (=13)
+Standards-Version: 4.5.1
 Homepage: https://github.com/apangin/jattach
 Vcs-Browser: https://git.sven.stormbind.net/?p=sven/jattach.git
 Vcs-Git: https://git.sven.stormbind.net/jattach.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_install:
	install --mode=755 build/jattach debian/jattach/usr/bin/jattach

## jattach 2.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-JATTACH_VERSION=2.0
+JATTACH_VERSION=2.1
 
 ifneq ($(findstring Windows,$(OS)),)
   CL=cl.exe
@@ -6,13 +6,14 @@
   JATTACH_EXE=jattach.exe
   JATTACH_DLL=jattach.dll
 else 
-  CFLAGS ?= -O3
   JATTACH_EXE=jattach
 
   UNAME_S:=$(shell uname -s)
   ifeq ($(UNAME_S),Darwin)
+    CFLAGS ?= -O3 -arch x86_64 -arch arm64 -mmacos-version-min=10.12
     JATTACH_DLL=libjattach.dylib
   else
+    CFLAGS ?= -O3
     JATTACH_DLL=libjattach.so
   endif
 
@@ -38,7 +39,7 @@
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -DJATTACH_VERSION=\"$(JATTACH_VERSION)\" -o $@ src/posix/*.c
 
 build/$(JATTACH_DLL): src/posix/*.c src/posix/*.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -DJATTACH_VERSION=\"$(JATTACH_VERSION)\" -fPIC -shared -fvisibility=hidden -o $@ src/posix/*.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -fPIC -shared -fvisibility=hidden -o $@ src/posix/*.c
 
 build/jattach.exe: src/windows/jattach.c
 	$(CL) $(CFLAGS) /DJATTACH_VERSION=\"$(JATTACH_VERSION)\" /Fobuild/jattach.obj /Fe$@ $^ advapi32.lib /link /SUBSYSTEM:CONSOLE,5.02

=== debian/changelog ===
jattach (2.1-1) unstable; urgency=medium

  [ Sven Hoexter ]
  * New upstream release.
  * Update Standards-Version to 4.6.1 - no changes required.
  * Drop additional LDFLAGS -Wl,--as-needed.
  * Update dates to 2022 in debian/copyright.
  * Set Rules-Requires-Root: no in debian/control.

 -- Sven Hoexter <hoexter@debian.org>  Mon, 25 Jul 2022 21:01:27 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Sven Hoexter <hoexter@debian.org>
 Build-Depends: debhelper-compat (=13)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/apangin/jattach
 Vcs-Browser: https://git.sven.stormbind.net/?p=sven/jattach.git
 Vcs-Git: https://git.sven.stormbind.net/jattach.git
+Rules-Requires-Root: no
 
 Package: jattach
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
 	dh $@

=== debian/watch ===
version=4
https://github.com/apangin/jattach/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## jattach 2.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-JATTACH_VERSION=2.1
+JATTACH_VERSION=2.2
 
 ifneq ($(findstring Windows,$(OS)),)
   CL=cl.exe

=== debian/changelog ===
jattach (2.2-2) unstable; urgency=medium

  * d/control: Drop Rules-Requires-Root: no, it's the default now.
  * Update to Standards-Version 4.7.3, remove the Priority field.
  * d/watch: Update to version 5.
  * Prefix dh configuration files with binary package name.

 -- Sven Hoexter <hoexter@debian.org>  Tue, 06 Jan 2026 23:13:26 +0100

jattach (2.2-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.6.2 no changes required.
  * Update debian/copyright, remove years for debian/* content.

 -- Sven Hoexter <hoexter@debian.org>  Tue, 16 Jan 2024 13:49:13 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,11 @@
 Source: jattach
 Section: java
-Priority: optional
 Maintainer: Sven Hoexter <hoexter@debian.org>
 Build-Depends: debhelper-compat (=13)
-Standards-Version: 4.6.1
+Standards-Version: 4.7.3
 Homepage: https://github.com/apangin/jattach
 Vcs-Browser: https://git.sven.stormbind.net/?p=sven/jattach.git
 Vcs-Git: https://git.sven.stormbind.net/jattach.git
-Rules-Requires-Root: no
 
 Package: jattach
 Architecture: any

=== debian/watch ===
Version: 5
Template: Github
Owner: apangin
Project: jattach
